public class Edge{
   private Node src;
   private Node dst;
   private int ch;

   public static int edge_Dominator   = 1; 
   public static int edge_Back_join   = 2;
   public static int edge_Cross_join  = 4;
   public static int edge_Sp_back     = 8;
   public static int edge_Sp_tree     = 16;
   public static int edge_Sp_forward  = 32;
   public static int edge_Sp_cross    = 64;

   public String toString(){
      String out ="";
      out += src.getSignature() + " -> " + dst.getSignature() ;
      return out;
   }
   
   public Edge( Node src, Node dst ){
      this.src = src;
      this.dst = dst;
      ch = 0;
   }

   public void setSrc( Node n ){
      src = n;
   }

   public void setDst( Node n ){
      dst = n;
   }

   public Node getSrc(){
      return src;
   }
   
   public Node getDst(){
      return dst;
   }

   public void setCh( int i ){
      ch = i;
   }

   public int getCh(){
      return ch;
   }

   public boolean isIrrEdge(){
      int res = ch;
      res &= ( edge_Cross_join + edge_Sp_back );
      if( res == ch )
	 return true;
      else
	 return false;
   }

   public boolean isBJEdge(){
      int res = ch;
      res &= edge_Back_join;
      if( res > 0 )
	 return true;
      else
	 return false;
   }

}
