import java.util.ArrayList;

public class EdgeList{
   private ArrayList a;
   
   public EdgeList(){
      a = new ArrayList();
   }

   public int size(){
      return a.size();
   }

   public void add( Edge e ){
      a.add(e);
   }

   public Edge get( int i ){
      return (Edge)a.get(i);
   }
   
   public boolean containsSrc( Node n ){
      for( int i = 0; i < a.size() ; i ++ ){
	 Node t = ((Edge)a.get(i)).getSrc();
	 if( t == n )return true;
      }
      return false;
   }

   public void extend( EdgeList el ){
      for( int i = 0; i < el.size() ; i ++ ){
	 Edge e = (Edge)el.get(i);
	 if( !a.contains(e) )
	    a.add(e);
      }
   }

}
